unit PixMix_U;
{$A-}
{
Zweck : Herstellen von Stereo-Bildern
Autor : Peter Rothfels
Start : V 1.0  02.07.1999
Stand : V 1.0  02.07.1999 Ausgabe als "Schwarzwei" - Bild fr
                         Rot/Cyan - Brille : linkes Auge rot, rechtes cyan
                         Sprachen: englisch und deutsch Compilerdirektive GERMAN
        V 1.1  08.07.1999 Erweiterung auf Farbausgabe, Facelift
        V 1.11 11.07.1999 neue Dateiauswahlbox fr Bildquellen
               27.08.1999 DepthBar von +-80 auf +-20 gendert
        V 1.2  30.08.1999 Button zum Verkleinern des Hauptfensters
        V 1.3  05.09.1999 Spinboxen zum Einstellen von in/out und up/down
                          statt der Schieberegler

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Gauges, ClipBrd, Buttons, Source_U, Stereo_U,
  Spin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    LoadButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    MixButton: TButton;
    MixGauge: TGauge;
    StopButton: TButton;
    MultiButton: TButton;
    SaveDialog: TSaveDialog;
    StatusBar: TStatusBar;
    AppNamePanel: TPanel;
    AppNameBlackLabel: TLabel;
    AppNameCyanLabel: TLabel;
    AppNameRedLabel: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ResetButton: TButton;
    MonoCheck: TCheckBox;
    Timer1: TTimer;
    RedBar: TTrackBar;
    RedLabel: TLabel;
    GreenBar: TTrackBar;
    GreenLabel: TLabel;
    BlueBar: TTrackBar;
    BlueLabel: TLabel;
    GammaBar: TTrackBar;
    GammaLabel: TLabel;
    RedReset: TSpeedButton;
    GreenReset: TSpeedButton;
    BlueReset: TSpeedButton;
    GammaReset: TSpeedButton;
    FormHideButton: TSpeedButton;
    DepthSpin: TSpinEdit;
    UpDownSpin: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure MonoCheckClick(Sender: TObject);
    procedure MixButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure MultiButtonClick(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RedResetClick(Sender: TObject);
    procedure GreenResetClick(Sender: TObject);
    procedure BlueResetClick(Sender: TObject);
    procedure GammaResetClick(Sender: TObject);
    procedure FormHideButtonClick(Sender: TObject);
    procedure StatusBarDblClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure Blend24Bit;
    procedure WriteBmpFile(BmpFileName : TFileName);
  end;

   TPrbmpHeader = packed Record
                    {File - Header}
                    BmpType1  : Byte;
                    BmpType2  : Byte;
                    FileSize  : LongInt;
                    Dummy     : LongInt;
                    PicOffset : LongInt;
                    {Bitmap Info - Header}
                    HdrSize,
                    Width,
                    Height          : LongInt;
                    Planes,
                    BitsPerPixel    : Word;
                    Compression,
                    ImageSize,
                    XPelsPerMeter,
                    YpelsPerMeter,
                    ColorsUsed,
                    ColorsImportant : LongInt;
                  End;
CONST
  MaxPixelCount   =  32768;

TYPE
  pRGBArray  =  ^TRGBArray;
  TRGBArray  =  ARRAY[0..MaxPixelCount-1] OF TRGBTriple;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  FormFullSize : Boolean = true;

var
  FwStart : Byte;
  Mixing, CancelMix : Boolean;
  Form_W, Form_H,
  ImgHeight,
  ImgWidth   : LongInt;
  Freeware : String;




procedure TForm1.WriteBmpFile(BmpFileName : TFileName);
var
  BmpFile : File of Byte;
  BmpHdr  : TPrBmpHeader;
  PicRow  : pRGBArray;
  L,
  Y       : LongInt;
  NullByte,
  B, Rest : Byte;

begin
  with BmpHdr do
  begin
    BmpType1 := $42;
    BmpType2 := $4D;
    Width := StereoForm.Image3.Picture.Bitmap.Width;
    Height := StereoForm.Image3.Picture.Bitmap.Height;
    ImageSize := 3 * Height * (Width + (Width Mod 4));
    FileSize := 54 + ImageSize;
    Dummy := 0;
    PicOffset := 54;
    HdrSize := 40;
    Planes := 1;
    BitsPerPixel := 24;
    Compression := 0;
    XPelsPerMeter := 11811;
    YPelsPerMeter := 11811;
    ColorsUsed := 0;
    ColorsImportant := 0;
  end;
  L := 3 * BmpHdr.Width;
  NullByte := 0;
  Rest := BmpHdr.Width Mod 4;
  AssignFile(BmpFile, BmpFileName);
  ReWrite(BmpFile);
  BlockWrite(BmpFile, BmpHdr, SizeOf(BmpHdr));
  for Y := StereoForm.Image3.Picture.Bitmap.Height-1 DownTo 0 do
  begin
    PicRow := StereoForm.Image3.Picture.Bitmap.Scanline[Y];
    BlockWrite(BmpFile, PicRow^, L);
    for B := 1 to Rest do Write(BmpFile, NullByte);
  end;
  CloseFile(BmpFile);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Mixing := false;
  CancelMix := false;
{$IFDEF GERMAN}
  Label1.Caption := '- raus';
  Label2.Caption := '+ rein';
  Label3.Caption := 'rauf';
  Label4.Caption := 'runter';
  LoadButton.Caption := '&lade Einzelbilder';
  MixButton.Caption := '&3D erzeugen';
  MultiButton.Caption := '3D-Bild &sichern';
  AppNameCyanLabel.Font.Color := $C0C000;
  AppNameRedLabel.Font.Color := $C0;
{$ENDIF}
end;

procedure TForm1.LoadButtonClick(Sender: TObject);
begin
  SourceBmpForm.ShowModal;
  if SourceBmpForm.Execute then
  begin
    Image1.Picture.LoadFromFile(Pic1Name);
    Image2.Picture.LoadFromFile(Pic2Name);
    StereoForm.Image3.Picture.LoadFromFile(Pic1Name);
    MixButton.Enabled := true;
    MultiButton.Enabled := true;
  end;
end;

procedure TForm1.Blend24Bit;
var
  Pic1Row,
  Pic2Row,
  Pic3Row    : pRGBArray;
  Pic1Pixel,
  Pic2Pixel,
  Pic3Pixel  : TRGBTriple;
  GammaArr : Array[0..255] of Byte;
  OffsetX1, OffsetY1,
  OffsetX2, OffsetY2,
  OffsetX, OffsetY,
  LeftI, RightI,
  TopI, BottomI,
  I,
  X, Y       : Integer;
  GrayRightB : Byte;
  RefreshPic3 : LongInt;
  E1, E2, E3, E4, E5,
  RedLeft,
  GreenRight,
  BlueRight,
  GrayLeft, GrayRight : Extended;

begin
  GammaArr[0] := 0;
  for I := 1 to 255 do
  begin
    E1 := 127 - I;
    E2 := Abs(E1/128);
    E3 := E2 * E2;
    E4 := 1 - E3;
    E5 := I - E4 * GammaBar.Position;
    if E5 < 0 then E5 := 0 else
    if E5 > 255 then E5 := 255;
    GammaArr[I] := Round(E5);
  end;
  MixGauge.ForeColor := clBlue;
  RefreshPic3 := ImgHeight Div 25;
  if RefreshPic3 = 0 then RefreshPic3 := 1;
  I := abs(DepthSpin.Value) Div 2;
  if DepthSpin.Value > 0 then OffsetX1 := -I else OffsetX1 := I;
  I := abs(UpDownSpin.Value) Div 2;
  if UpDownSpin.Value > 0 then OffsetY1 := -I else OffsetY1 := I;
  OffsetX2 := OffsetX1;
  OffsetY2 := OffsetY1;
  if abs(DepthSpin.Value) Mod 2 = 1 then
  begin
    if OffsetX1 >= 0
    then Dec(OffsetX2)
    else Inc(OffsetX2);
  end;
  if abs(UpDownSpin.Value) Mod 2 = 1 then
  begin
    if OffsetY1 >= 0
    then Inc(OffsetY2)
    else Dec(OffsetY2);
  end;
  if abs(OffsetX1) >= abs(OffsetX2)
  then OffsetX := OffsetX1
  else OffsetX := OffsetX2;
  if abs(OffsetY1) >= abs(OffsetY2)
  then OffsetY := OffsetY1
  else OffsetY := OffsetY2;
  LeftI := Abs(OffsetX);
  TopI := Abs(OffsetY);
  RightI := ImgWidth - Abs(OffsetX) - 1;
  BottomI := ImgHeight - Abs(OffsetY) - 1;
  Width3D := RightI - LeftI + 1;
  Height3D := BottomI - TopI + 1;
  StereoForm.Image3.Picture.Bitmap.Width := Width3D;
  StereoForm.Image3.Picture.Bitmap.Height := Height3D;
  StereoForm.PicPanel.Width := Round(Scale * Width3D);
  StereoForm.PicPanel.Height := Round(Scale * Height3D);
  StereoForm.Image3.visible := true;
  for Y := TopI to BottomI do
  begin
    for X := LeftI to RightI do
    begin
      if CancelMix then Exit;
      Pic1Row := Image1.Picture.Bitmap.Scanline[Y-OffsetY1];
      Pic2Row := Image2.Picture.Bitmap.Scanline[Y+OffsetY2];
      Pic3Row := StereoForm.Image3.Picture.Bitmap.Scanline[Y-TopI];
      try
        Pic1Pixel := Pic1Row[X-OffsetX1];
      except
        exit;
      end;
      try
        Pic2Pixel := Pic2Row[X+OffsetX2];
      except
        exit;
      end;
      try
        Pic3Pixel := Pic3Row[X-LeftI];
      except
        exit;
      end;

      Case MonoCheck.State of
      cbChecked :
        begin
          GrayLeft :=  Pic1Pixel.rgbtBlue+Pic1Pixel.rgbtGreen+Pic1Pixel.rgbtRed;
          GrayRight := Pic2Pixel.rgbtBlue+Pic2Pixel.rgbtGreen+Pic2Pixel.rgbtRed;
          GrayRightB := Round(GrayRight/3);

          Pic3Pixel.rgbtRed := GammaArr[Round(GrayLeft/3)];
          Pic3Pixel.rgbtGreen := GammaArr[GrayRightB];
          Pic3Pixel.rgbtBlue  := GammaArr[GrayRightB];
        end;
      cbGrayed :
        begin
          GrayLeft :=  96 + Pic1Pixel.rgbtBlue
                          + Pic1Pixel.rgbtGreen
                          + Pic1Pixel.rgbtRed
                          - 3 * RedBar.Position;
          if GrayLeft > 765 then GrayLeft := 765;
          GreenRight := Pic2Pixel.rgbtGreen - GreenBar.Position;
          if GreenRight > 255 then GreenRight := 255 else
          if GreenRight < 0 then GreenRight := 0;
          BlueRight  := Pic2Pixel.rgbtBlue - BlueBar.Position;
          if BlueRight > 255 then BlueRight := 255 else
          if BlueRight < 0 then BlueRight := 0;

          Pic3Pixel.rgbtRed := GammaArr[Round(GrayLeft/3)];
          Pic3Pixel.rgbtGreen := GammaArr[Round(GreenRight)];
          Pic3Pixel.rgbtBlue  := GammaArr[Round(BlueRight)];
        end;
      cbUnChecked :
        begin
          RedLeft    := Pic1Pixel.rgbtRed - RedBar.Position;
          if RedLeft > 255 then RedLeft := 255 else
          if RedLeft < 0 then RedLeft := 0;
          GreenRight := Pic2Pixel.rgbtGreen - GreenBar.Position;
          if GreenRight > 255 then GreenRight := 255 else
          if GreenRight < 0 then GreenRight := 0;
          BlueRight  := Pic2Pixel.rgbtBlue - BlueBar.Position;
          if BlueRight > 255 then BlueRight := 255 else
          if BlueRight < 0 then BlueRight := 0;

          Pic3Pixel.rgbtRed   := GammaArr[Round(RedLeft)];
          Pic3Pixel.rgbtGreen := GammaArr[Round(GreenRight)];
          Pic3Pixel.rgbtBlue  := GammaArr[Round(BlueRight)];
        end;
      end;

      Pic3Row[X-LeftI] := Pic3Pixel;
    end;
    if Y Mod RefreshPic3 = 0 then StereoForm.Image3.Refresh;
    if y mod 10 = 0 then MixGauge.Progress := Y;
    Application.ProcessMessages;
  end;
  StereoForm.Image3.Refresh;
end;

procedure TForm1.MonoCheckClick(Sender: TObject);
begin
  RedBar.Enabled := MonoCheck.State <> cbChecked;
  GreenBar.Enabled := MonoCheck.State <> cbChecked;
  BlueBar.Enabled := MonoCheck.State <> cbChecked;
  RedLabel.Enabled := MonoCheck.State <> cbChecked;
  GreenLabel.Enabled := MonoCheck.State <> cbChecked;
  BlueLabel.Enabled := MonoCheck.State <> cbChecked;
end;

procedure TForm1.MixButtonClick(Sender: TObject);
var
  PrevTimerStat : Boolean;

begin
  Image1.Picture.Bitmap.PixelFormat := pf24bit;
  Image2.Picture.Bitmap.PixelFormat := pf24bit;
  StereoForm.Image3.Picture.Bitmap.PixelFormat := pf24bit;
  StopButton.enabled := true;
  StopButton.visible := true;
  MixButton.enabled := false;
  MixButton.visible := false;
  {$IFDEF GERMAN}
  MultiButton.Caption := '&Anzeige ein/aus';
  {$ELSE}
  MultiButton.Caption := 'Show/&Hide';
  {$ENDIF}
  CancelMix := false;
  Mixing := true;
  ImgWidth  := Image1.Picture.Width;
  ImgHeight := Image1.Picture.Height;
  if ImgWidth > Image2.Picture.Width then ImgWidth := Image2.Picture.Width;
  if ImgHeight > Image2.Picture.Height then ImgHeight := Image2.Picture.Height;
  MixGauge.MaxValue := ImgHeight - 1;
  MixGauge.Progress := 0;
  DepthSpin.Enabled := false;
  UpDownSpin.Enabled := false;
  RedBar.Enabled := false;
  GreenBar.Enabled := false;
  BlueBar.Enabled := false;
  GammaBar.Enabled := false;
  PrevTimerStat := Timer1.Enabled;
  Timer1.Enabled := false;
  MonoCheck.Enabled := false;
  ResetButton.Enabled := false;
  LoadButton.visible := false;
  MixGauge.Visible := true;
  StereoForm.Show;

  Blend24Bit;

  MixGauge.Visible := false;
  LoadButton.visible := true;
  StereoForm.Image3.visible := true;
  ResetButton.Enabled := true;
  Timer1.Enabled := PrevTimerStat;
  MonoCheck.Enabled := true;
  UpDownSpin.Enabled := true;
  DepthSpin.Enabled := true;
  MonoCheckClick(Self);
  GammaBar.Enabled := true;
  StopButton.enabled := false;
  StopButton.visible := false;
  MixButton.enabled := true;
  MixButton.visible := true;
  Mixing := false;
  {$IFDEF GERMAN}
  MultiButton.Caption := '3D-Bild &sichern';
  {$ELSE}
  MultiButton.Caption := '&Save 3D Image';
  {$ENDIF}
end;


procedure TForm1.StopButtonClick(Sender: TObject);
begin
  CancelMix := true;
  MixGauge.Visible := false;
  LoadButton.visible := true;
  StopButton.enabled := false;
  StopButton.visible := false;
  MixButton.enabled := true;
  MixButton.visible := true;
  Mixing := false;
  MultiButton.enabled := true;
  {$IFDEF GERMAN}
  MultiButton.Caption := 'Mischung &sichern';
  {$ELSE}
  MultiButton.Caption := '&Save mixed Img.';
  {$ENDIF}
end;

procedure TForm1.MultiButtonClick(Sender: TObject);
begin
  if Mixing then StereoForm.Image3.visible := not StereoForm.Image3.visible else
  if SaveDialog.Execute
  then WriteBmpFile(SaveDialog.Filename);
end;

procedure TForm1.ResetButtonClick(Sender: TObject);
begin
  UpDownSpin.Value := 0;
  DepthSpin.Value := 0;
  RedBar.Position := 0;
  GreenBar.Position := 0;
  BlueBar.Position := 0;
  GammaBar.Position := 0;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  FwStart := 0;
  Freeware := '------------------------- '
{$IFDEF GERMAN}
            + 'dies ist Freeware - Nutzung auf eigene Gefahr - keine Haftung'
{$ELSE}
            + 'this is freeware  -----  use at own risk  ------  no warranty'
{$ENDIF}
            + ' -------------------------';
  RedBar.SetTick(0);
  GammaBar.SetTick(0);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  StatusBar.Panels[2].Text := Copy(Freeware, FwStart + 1, 26);
  Inc(FwStart);
  FwStart := FwStart Mod 87;
end;





procedure TForm1.RedResetClick(Sender: TObject);
begin
  RedBar.Position := 0;
end;

procedure TForm1.GreenResetClick(Sender: TObject);
begin
  GreenBar.Position := 0;
end;

procedure TForm1.BlueResetClick(Sender: TObject);
begin
  BlueBar.Position := 0;
end;

procedure TForm1.GammaResetClick(Sender: TObject);
begin
  GammaBar.Position := 0;
end;

procedure TForm1.FormHideButtonClick(Sender: TObject);
begin
  if FormFullSize then
  begin
    Form_W := Form1.ClientWidth;
    Form_H := Form1.ClientHeight;
    StatusBar.Visible := false;
    Form1.BorderStyle := bsToolWindow;
    Form1.ClientWidth := FormHideButton.Width;
    Form1.ClientHeight := FormHideButton.Height;
    Form1.Top := Form1.Top + 3;
  end
  else
  begin
    Form1.Top := Form1.Top - 3;
    Form1.BorderStyle := bsSingle;
    StatusBar.Visible := true;
    Form1.ClientWidth := Form_W;
    Form1.ClientHeight := Form_H;
  end;
  FormFullSize := not FormFullSize;
end;

procedure TForm1.StatusBarDblClick(Sender: TObject);
begin
  Timer1.Enabled := not Timer1.Enabled;
end;


end.

